import { useCssVars as lt, computed as h, ref as f, watch as Se, onMounted as at, watchEffect as ot, openBlock as s, createElementBlock as i, normalizeClass as Fe, normalizeStyle as X, unref as c, createBlock as T, createCommentVNode as y, renderSlot as m, createSlots as st, withCtx as C, normalizeProps as E, guardReactiveProps as D, createVNode as rt, Fragment as O, renderList as se, createElementVNode as k, toDisplayString as L, createTextVNode as nt, nextTick as ut } from "vue";
import { u as it, c as Me, t as ct, a as re, p as P, o as vt, e as dt, b as ht, d as Ne, m as ft, h as _e, f as ne, X as yt, l as pt, G as Y, i as Ae, q as mt, r as bt } from "./index-D7WbF7IL.js";
import { u as Ee } from "./useNestedProp-DrpjbpQG.js";
import { u as gt, U as kt } from "./usePrinter-Bsq_c-4R.js";
import { _ as xt } from "./Title-fuZYZTyg.js";
import { P as wt } from "./PenAndPaper-Yisw8HR-.js";
import { u as Ct } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as zt } from "./PackageVersion-DfaIDpJw.js";
import $t from "./vue-ui-accordion-Df7Z4z_I.js";
import { D as Pt } from "./DataTable-DkvQh989.js";
import Tt from "./vue-ui-skeleton-BP-sSOBv.js";
import { _ as Ot } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const It = ["id"], St = ["xmlns", "viewBox"], Ft = ["x", "y", "width", "height"], Mt = ["id"], Nt = ["stop-color"], _t = ["stop-color"], At = ["stop-color"], Et = { key: 0 }, Dt = ["x", "y", "width", "height", "stroke", "stroke-width", "fill", "rx", "onMouseenter"], Lt = ["x", "y", "width", "height", "stroke", "stroke-width", "fill", "rx"], Rt = ["opacity", "x", "y", "font-size", "fill", "font-weight"], Gt = ["opacity", "x", "y", "font-size", "fill", "font-weight"], Ut = ["d", "fill"], Vt = ["cx", "cy", "r", "opacity", "stroke", "fill"], Bt = {
  key: 0,
  style: { pointerEvents: "none" }
}, Ht = { key: 1 }, Xt = ["opacity", "x", "y", "font-size", "fill", "font-weight"], Yt = ["opacity", "x", "y", "font-size", "fill", "font-weight"], Wt = {
  key: 6,
  class: "vue-data-ui-watermark"
}, jt = ["innerHTML"], qt = {
  __name: "vue-ui-circle-pack",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(De, { expose: Le }) {
    const z = De;
    lt((t) => ({
      "5d52776a": F.value,
      "1daa5de3": J.value
    }));
    const { vue_ui_circle_pack: Re } = it(), R = h(() => !!z.dataset && z.dataset.length), I = f(Me()), W = f(null), Ge = f(null), Ue = f(null), ue = f(0), ie = f(0), ce = f(0), Ve = f(null), e = h({
      get: () => he(),
      set: (t) => t
    }), {
      userOptionsVisible: j,
      setUserOptionsVisibility: ve,
      keepUserOptionState: de
    } = Ct({ config: e.value });
    function he() {
      const t = Ee({
        userConfig: z.config,
        defaultConfig: Re
      });
      return t.theme ? {
        ...Ee({
          userConfig: ct.vue_ui_circle_pack[t.theme] || z.config,
          defaultConfig: t
        }),
        customPalette: re[t.theme] || P
      } : t;
    }
    Se(() => z.config, (t) => {
      e.value = he(), j.value = !e.value.userOptions.showOnChartHover, q(), ue.value += 1, ie.value += 1, S.value.showTable = e.value.table.show;
    }, { deep: !0 });
    const { isPrinting: fe, isImaging: ye, generatePdf: pe, generateImage: me } = gt({
      elementId: `vue-ui-circle-pack_${I.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-circle-pack"
    }), Be = h(() => e.value.userOptions.show && !e.value.style.chart.title.text), S = f({
      showTable: e.value.table.show
    });
    async function q() {
      vt(z.dataset) && dt({
        componentName: "VueUiCirclePack",
        type: "dataset"
      }), await We();
    }
    at(q), Se(() => z.dataset, async (t) => {
      await q();
    }, { deep: !0 });
    const be = h(() => ht(e.value.customPalette));
    function ge(t, a) {
      return Math.hypot(a.x - t.x, a.y - t.y);
    }
    function ke(t, a) {
      return a.some((l) => ge(t, l) < t.radius + l.radius);
    }
    function He(t, a, l, n) {
      const v = a * 2;
      for (let x of t)
        for (let w = 0; w < 360; w += 30) {
          let A = w * Math.PI / 180, u = x.x + v * Math.cos(A), o = x.y + v * Math.sin(A), g = { x: u, y: o, radius: a };
          if (u - a >= 0 && u + a <= l && o - a >= 0 && o + a <= n && !ke(g, t))
            return { x: u, y: o };
        }
      return null;
    }
    function Xe(t, a, l, n, v = 0, x = 0) {
      const w = Math.max(...t.map((g) => g.value)), u = t.map((g, d) => ({
        ...g,
        radius: g.value / w * n,
        index: d
      })).map((g, d) => ({ ...g, index: d })).toSorted((g, d) => d.radius - g.radius);
      let o = [];
      o.push({
        ...u[0],
        x: a / 2 + v,
        y: l / 2 + x
      });
      for (let g of u.slice(1)) {
        let { radius: d, ...$e } = g, ee = He(o, d, a, l);
        if (ee)
          o.push({ ...$e, x: ee.x, y: ee.y, radius: d });
        else {
          let te = null, Pe = 1 / 0;
          for (let B of o)
            for (let le = 0; le < 360; le += 15) {
              let Te = le * Math.PI / 180, ae = B.x + (d + B.radius) * Math.cos(Te), oe = B.y + (d + B.radius) * Math.sin(Te), H = { ...$e, x: ae, y: oe, radius: d };
              if (ae - d >= 0 && ae + d <= a && oe - d >= 0 && oe + d <= l && !ke(H, o)) {
                let Oe = o.reduce(
                  (tt, Ie) => tt + (ge(H, Ie) < H.radius + Ie.radius ? 1 : 0),
                  0
                );
                Oe < Pe && (Pe = Oe, te = H);
              }
            }
          te && o.push(te);
        }
      }
      return o;
    }
    const Z = h(() => z.dataset.map((t, a) => {
      const l = Ne(t.color) || be.value[a] || re[e.value.theme || "default"][a % re[e.value.theme || "default"].length] || P[a] || P[a % P.length];
      return {
        ...t,
        id: Me(),
        color: l
      };
    }).filter((t) => ![null, void 0, 1 / 0, -1 / 0].includes(t.value))), b = f([]), Ye = h(() => Math.max(...b.value.map((t) => t.radius)));
    function xe(t, a) {
      return a / Ye.value * t;
    }
    async function We() {
      b.value = Xe(
        Z.value,
        // Huge plane size to place all datapoints
        1e4,
        1e4,
        32
      );
    }
    const we = h(() => ({
      width: 100,
      height: 100
    })), p = h(() => {
      const t = b.value.reduce((u, o) => o.x - o.radius < u.x - u.radius ? o : u, b.value[0]), a = b.value.reduce((u, o) => o.y - o.radius < u.y - u.radius ? o : u, b.value[0]), l = b.value.reduce((u, o) => o.x + o.radius > u.x + u.radius ? o : u, b.value[0]), n = b.value.reduce((u, o) => o.y + o.radius > u.y + u.radius ? o : u, b.value[0]), v = (t == null ? void 0 : t.x) || 0, x = (l == null ? void 0 : l.x) || we.value.width, w = (a == null ? void 0 : a.y) || 0, A = (n == null ? void 0 : n.y) || we.value.height;
      return {
        maxX: x,
        minX: v,
        width: Math.abs(x - v) + (t ? t.radius : 0) + (l ? l.radius : 0) + e.value.style.chart.circles.strokeWidth * 4,
        height: Math.abs(A - w) + (a ? a.radius : 0) + (n ? n.radius : 0) + e.value.style.chart.circles.strokeWidth * 4,
        x: t ? (t == null ? void 0 : t.x) - (t == null ? void 0 : t.radius) - e.value.style.chart.circles.strokeWidth * 2 : 0,
        y: a ? (a == null ? void 0 : a.y) - (a == null ? void 0 : a.radius) - e.value.style.chart.circles.strokeWidth * 2 : 0
      };
    }), je = h(() => b.value.map((t) => {
      if (t.breakdown)
        return ft(
          { series: t.breakdown.map((a, l) => ({
            ...a,
            color: Ne(a.color) || be.value[l] || P[l] || P[l % P.length]
          })) },
          t.x,
          t.y,
          t.radius,
          t.radius,
          1.99999,
          2,
          1,
          360,
          105.25,
          t.radius / 2
        );
    })), r = f(null);
    function qe(t) {
      e.value.style.chart.circles.zoom.show && (r.value = t);
    }
    const F = h(() => r.value ? r.value.radius : 0), J = h(() => r.value ? r.value.radius > p.value.width / 6 * e.value.style.chart.circles.zoom.zoomRatio ? r.value.radius : p.value.width / 6 * e.value.style.chart.circles.zoom.zoomRatio : 0), $ = f(0), Ze = h(() => ({
      pointerEvents: "none",
      opacity: $.value,
      filter: `drop-shadow(0px 0px 6px ${_e(r.value.color, e.value.style.chart.circles.zoom.shadowForce)})`
    })), M = f(F.value);
    ot(() => {
      M.value = F.value, $.value = 0;
      let t = null;
      function a(l) {
        t || (t = l);
        const n = (l - t) / e.value.style.chart.circles.zoom.animationFrameMs;
        n < 1 ? (M.value = F.value + (J.value - F.value) * n, $.value = 0 + e.value.style.chart.circles.zoom.opacity * n, requestAnimationFrame(a)) : (M.value = J.value, $.value = e.value.style.chart.circles.zoom.opacity);
      }
      requestAnimationFrame(a);
    });
    const N = h(() => ({
      name: e.value.style.chart.circles.zoom.label.name.fontSize * p.value.width / 300,
      value: e.value.style.chart.circles.zoom.label.value.fontSize * p.value.width / 300
    }));
    function K(t) {
      return Ae(
        e.value.style.chart.circles.labels.value.formatter,
        t.value,
        ne({
          p: e.value.style.chart.circles.labels.value.prefix,
          v: t.value,
          s: e.value.style.chart.circles.labels.value.suffix,
          r: e.value.style.chart.circles.labels.value.rounding
        })
      );
    }
    function Je() {
      return Ae(
        e.value.style.chart.circles.zoom.label.value.formatter,
        r.value.value,
        ne({
          p: e.value.style.chart.circles.zoom.label.value.prefix,
          v: r.value.value,
          s: e.value.style.chart.circles.zoom.label.value.suffix,
          r: e.value.style.chart.circles.zoom.label.value.rounding
        })
      );
    }
    function Ke(t) {
      if (!t)
        return 0;
      const a = t.radius / K(t).length * (K(t).length === 1 ? 1 : 2);
      return Math.min(t.radius / 2.5, a);
    }
    const _ = f(!1);
    function Qe(t) {
      _.value = t, ce.value += 1;
    }
    const G = f(!1);
    function Q() {
      G.value = !G.value;
    }
    const U = h(() => {
      const t = Z.value.map((l) => ({
        name: l.name,
        value: l.value,
        color: l.color
      })).toSorted((l, n) => n.value - l.value), a = t.map((l) => l.value);
      return { head: t, body: a };
    });
    function Ce() {
      ut(() => {
        const t = U.value.head.map((n, v) => [[
          n.name
        ], [U.value.body[v]]]), a = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [[""], [e.value.table.columnNames.value]]].concat(t), l = mt(a);
        bt({ csvContent: l, title: e.value.style.chart.title.text || "vue-ui-circle-pack" });
      });
    }
    const V = h(() => {
      const t = [
        e.value.table.columnNames.datapoint,
        e.value.table.columnNames.value
      ], a = U.value.head.map((v, x) => {
        const w = ne({
          p: e.value.style.chart.circles.labels.value.prefix,
          v: U.value.body[x],
          s: e.value.style.chart.circles.labels.value.suffix,
          r: e.value.style.chart.circles.labels.value.rounding
        });
        return [
          {
            color: v.color,
            name: v.name
          },
          w
        ];
      }), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.datapoint,
          e.value.table.columnNames.value
        ],
        head: t,
        body: a,
        config: l
      };
    });
    function ze() {
      S.value.showTable = !S.value.showTable;
    }
    function et() {
      return Z.value;
    }
    return Le({
      getData: et,
      generateCsv: Ce,
      generatePdf: pe,
      generateImage: me,
      toggleTable: ze,
      toggleAnnotator: Q
    }), (t, a) => (s(), i("div", {
      id: `vue-ui-circle-pack_${I.value}`,
      class: Fe(`vue-ui-circle-pack ${_.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      ref_key: "circlePackChart",
      ref: W,
      style: X(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      onMouseenter: a[2] || (a[2] = () => c(ve)(!0)),
      onMouseleave: a[3] || (a[3] = () => c(ve)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (s(), T(wt, {
        key: 0,
        parent: W.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: G.value,
        onClose: Q
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : y("", !0),
      m(t.$slots, "userConfig", {}, void 0, !0),
      Be.value ? (s(), i("div", {
        key: 1,
        ref_key: "noTitle",
        ref: Ue,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : y("", !0),
      e.value.style.chart.title.text ? (s(), i("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: Ge,
        style: "width:100%;background:transparent;padding-bottom:12px"
      }, [
        (s(), T(xt, {
          key: `title_${ue.value}`,
          config: {
            title: {
              cy: "donut-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : y("", !0),
      e.value.userOptions.show && R.value && (c(de) || c(j)) ? (s(), T(kt, {
        ref: "details",
        key: `user_option_${ce.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: c(fe),
        isImaging: c(ye),
        uid: I.value,
        hasTooltip: !1,
        hasLabel: !1,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: _.value,
        chartElement: W.value,
        position: e.value.userOptions.position,
        titles: { ...e.value.userOptions.buttonTitles },
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: G.value,
        onToggleFullscreen: Qe,
        onGeneratePdf: c(pe),
        onGenerateCsv: Ce,
        onGenerateImage: c(me),
        onToggleTable: ze,
        onToggleAnnotator: Q,
        style: X({
          visibility: c(de) ? c(j) ? "visible" : "hidden" : "visible"
        })
      }, st({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: C(() => [
            m(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: C(() => [
            m(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: C(() => [
            m(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: C(() => [
            m(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: C(({ toggleFullscreen: l, isFullscreen: n }) => [
            m(t.$slots, "optionFullscreen", E(D({ toggleFullscreen: l, isFullscreen: n })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: C(({ toggleAnnotator: l, isAnnotator: n }) => [
            m(t.$slots, "optionAnnotator", E(D({ toggleAnnotator: l, isAnnotator: n })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "chartElement", "position", "titles", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : y("", !0),
      R.value ? (s(), i("svg", {
        key: 4,
        xmlns: c(yt),
        viewBox: `${p.value.x} ${p.value.y} ${p.value.width} ${p.value.height}`,
        width: "100%",
        class: Fe({ "vue-data-ui-fullscreen--on": _.value, "vue-data-ui-fulscreen--off": !_.value }),
        style: X(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.chart.color};`)
      }, [
        rt(zt),
        t.$slots["chart-background"] ? (s(), i("foreignObject", {
          key: 0,
          x: p.value.x,
          y: p.value.y,
          width: p.value.width,
          height: p.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          m(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, Ft)) : y("", !0),
        (s(!0), i(O, null, se(b.value, (l) => (s(), i(O, null, [
          k("defs", null, [
            k("radialGradient", {
              id: l.id,
              fy: "30%"
            }, [
              k("stop", {
                offset: "10%",
                "stop-color": c(pt)(l.color, e.value.style.chart.circles.gradient.intensity / 100)
              }, null, 8, Nt),
              k("stop", {
                offset: "90%",
                "stop-color": c(_e)(l.color, 0.1)
              }, null, 8, _t),
              k("stop", {
                offset: "100%",
                "stop-color": l.color
              }, null, 8, At)
            ], 8, Mt)
          ]),
          t.$slots.pattern ? (s(), i("g", Et, [
            k("defs", null, [
              m(t.$slots, "pattern", E(D({ ...l, patternId: `pattern_${I.value}_${l.id}` })), void 0, !0)
            ])
          ])) : y("", !0),
          k("rect", {
            x: l.x - l.radius,
            y: l.y - l.radius,
            width: l.radius * 2,
            height: l.radius * 2,
            stroke: e.value.style.chart.circles.stroke,
            "stroke-width": e.value.style.chart.circles.strokeWidth,
            fill: e.value.style.chart.circles.gradient.show ? `url(#${l.id})` : l.color,
            rx: l.radius,
            onMouseenter: () => qe(l),
            onMouseout: a[0] || (a[0] = (n) => r.value = null)
          }, null, 40, Dt),
          t.$slots.pattern ? (s(), i("rect", {
            key: 1,
            x: l.x - l.radius,
            y: l.y - l.radius,
            width: l.radius * 2,
            height: l.radius * 2,
            stroke: e.value.style.chart.circles.stroke,
            "stroke-width": e.value.style.chart.circles.strokeWidth,
            fill: `url(#pattern_${I.value}_${l.id})`,
            rx: l.radius,
            style: {
              pointerEvents: "none"
            }
          }, null, 8, Lt)) : y("", !0),
          e.value.style.chart.circles.labels.name.show && l.name ? (s(), i("text", {
            key: 2,
            style: {
              pointerEvents: "none",
              transition: "opacity 0.2s ease-in-out"
            },
            opacity: r.value ? 0.2 : 1,
            x: l.x,
            y: l.y + xe(l.radius, e.value.style.chart.circles.labels.name.offsetY) - l.radius / 6,
            "font-size": l.radius / 3 * e.value.style.chart.circles.labels.name.fontSizeRatio,
            fill: e.value.style.chart.circles.labels.name.color ? e.value.style.chart.circles.labels.name.color : c(Y)(l.color),
            "font-weight": e.value.style.chart.circles.labels.name.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, L(l.name), 9, Rt)) : y("", !0),
          e.value.style.chart.circles.labels.value.show ? (s(), i("text", {
            key: 3,
            style: {
              pointerEvents: "none",
              transition: "opacity 0.2s ease-in-out"
            },
            opacity: r.value ? 0.2 : 1,
            x: l.x,
            y: l.y + xe(l.radius, e.value.style.chart.circles.labels.value.offsetY) + l.radius / 3,
            "font-size": Ke(l) * e.value.style.chart.circles.labels.value.fontSizeRatio,
            fill: e.value.style.chart.circles.labels.value.color ? e.value.style.chart.circles.labels.value.color : c(Y)(l.color),
            "font-weight": e.value.style.chart.circles.labels.value.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, L(K(l)), 9, Gt)) : y("", !0),
          (s(!0), i(O, null, se(je.value, (n) => (s(), i(O, null, [
            (s(!0), i(O, null, se(n, (v) => (s(), i("path", {
              d: v.arcSlice,
              fill: v.color,
              stroke: "black"
            }, null, 8, Ut))), 256))
          ], 64))), 256))
        ], 64))), 256)),
        r.value && e.value.style.chart.circles.zoom.show ? (s(), i(O, { key: 1 }, [
          k("circle", {
            style: X(Ze.value),
            cx: r.value.x,
            cy: r.value.y,
            r: M.value,
            opacity: $.value,
            stroke: e.value.style.chart.circles.stroke,
            fill: e.value.style.chart.circles.gradient.show ? `url(#${r.value.id})` : r.value.color
          }, null, 12, Vt),
          t.$slots["zoom-label"] ? (s(), i("g", Bt, [
            m(t.$slots, "zoom-label", E(D({ ...r.value, zoomOpacity: $.value, currentRadius: M.value, fontSize: N.value })), void 0, !0)
          ])) : (s(), i("g", Ht, [
            k("text", {
              style: {
                pointerEvents: "none"
              },
              opacity: $.value,
              x: r.value.x,
              y: r.value.y + e.value.style.chart.circles.zoom.label.name.offsetY - N.value.name / 4,
              "text-anchor": "middle",
              "font-size": N.value.name,
              fill: e.value.style.chart.circles.zoom.label.name.color ? e.value.style.chart.circles.zoom.label.name.color : c(Y)(r.value.color),
              "font-weight": e.value.style.chart.circles.zoom.label.name.bold ? "bold" : "normal"
            }, L(r.value.name), 9, Xt),
            k("text", {
              style: {
                pointerEvents: "none"
              },
              opacity: $.value,
              x: r.value.x,
              y: r.value.y + N.value.value + e.value.style.chart.circles.zoom.label.value.offsetY,
              "text-anchor": "middle",
              "font-size": N.value.value,
              fill: e.value.style.chart.circles.zoom.label.value.color ? e.value.style.chart.circles.zoom.label.value.color : c(Y)(r.value.color),
              "font-weight": e.value.style.chart.circles.zoom.label.value.bold ? "bold" : "normal"
            }, L(Je()), 9, Yt)
          ]))
        ], 64)) : y("", !0),
        m(t.$slots, "svg", {
          svg: { ...p.value }
        }, void 0, !0)
      ], 14, St)) : y("", !0),
      R.value ? y("", !0) : (s(), T(Tt, {
        key: 5,
        config: {
          type: "circlePack",
          style: {
            color: "#CCCCCC"
          }
        }
      })),
      t.$slots.watermark ? (s(), i("div", Wt, [
        m(t.$slots, "watermark", E(D({ isPrinting: c(fe) || c(ye) })), void 0, !0)
      ])) : y("", !0),
      t.$slots.source ? (s(), i("div", {
        key: 7,
        ref_key: "source",
        ref: Ve,
        dir: "auto"
      }, [
        m(t.$slots, "source", {}, void 0, !0)
      ], 512)) : y("", !0),
      R.value ? (s(), T($t, {
        key: 8,
        hideDetails: "",
        config: {
          open: S.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: C(() => [
          (s(), T(Pt, {
            key: `table_${ie.value}`,
            colNames: V.value.colNames,
            head: V.value.head,
            body: V.value.body,
            config: V.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: a[1] || (a[1] = (l) => S.value.showTable = !1)
          }, {
            th: C(({ th: l }) => [
              k("div", {
                innerHTML: l,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, jt)
            ]),
            td: C(({ td: l }) => [
              nt(L(l.name || l), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 46, It));
  }
}, ul = /* @__PURE__ */ Ot(qt, [["__scopeId", "data-v-a401fe8b"]]);
export {
  ul as default
};
